<?php
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );
/*
* Special Products Module
*
* @version $Id: mod_virtuemart_featureprod_advanced.php 1159 2008-01-14 20:30:30Z soeren_nb $
* @package VirtueMart
* @subpackage modules
*
* 	@copyright (C) 2000 - 2004 Mr PHP
// W: www.mrphp.com.au
// E: info@mrphp.com.au
// P: +61 418 436 690
* Conversion to Mambo and many enhancements:
* 	@copyright (C) 2004-2005 Soeren Eberhardt
*
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* VirtueMart is Free Software.
* VirtueMart comes with absolute no warranty.
*
* www.virtuemart.net
*/
global $mosConfig_absolute_path;

// Load the virtuemart main parse code
if( file_exists(dirname(__FILE__).'/../../components/com_virtuemart/virtuemart_parser.php' )) {
	require_once( dirname(__FILE__).'/../../components/com_virtuemart/virtuemart_parser.php' );
} else {
	require_once( dirname(__FILE__).'/../components/com_virtuemart/virtuemart_parser.php' );
}

$max_items = $params->get( 'max_items', 2 ); //maximum number of items to display
$category_id = $params->get( 'category_id', null ); // Display products from this category only
$only_active_category = $params->get( 'only_active_category', 0 ); // Display products from the active category
$display_style = $params->get( 'display_style', "vertical" ); // Display Style
$products_per_row = $params->get( 'products_per_row', 4 ); // Display X products per Row
$show_price = (bool)$params->get( 'show_price', 1 ); // Display the Product Price?
$show_addtocart = (bool)$params->get( 'show_addtocart', 1 ); // Display the "Add-to-Cart" Link?
$personal_template = (bool)$params->get( 'personal_template', 0 );
$show_product_title = $params->get( 'show_product_title', "above" );
$title_font_size = $params->get( 'title_font_size', "" );
$title_font_color = $params->get( 'title_font_color', "" );
$price_font_size = $params->get( 'price_font_size', "" );
$price_font_color = $params->get( 'price_font_color', "" );

$db = new ps_DB;

$active_category = vmGet( $_REQUEST, 'category_id', 0 );

if ( $only_active_category && $active_category ) {
	$q  = "SELECT DISTINCT product_sku FROM #__{vm}_product, #__{vm}_product_category_xref, #__{vm}_category WHERE \n";
	$q .= "(#__{vm}_product.product_parent_id='' OR #__{vm}_product.product_parent_id='0') \n";
	$q .= "AND #__{vm}_product.product_id=#__{vm}_product_category_xref.product_id \n";
	$q .= "AND #__{vm}_category.category_id=#__{vm}_product_category_xref.category_id \n";
	$q .= "AND #__{vm}_category.category_id='$active_category' \n";
	$q .= "AND #__{vm}_product.product_publish='Y' \n";
	$q .= "AND #__{vm}_product.product_special='Y' \n";
	if( CHECK_STOCK && PSHOP_SHOW_OUT_OF_STOCK_PRODUCTS != "1") {
		$q .= " AND product_in_stock > 0 \n";
	}
	$q .= "ORDER BY RAND() LIMIT 0, $max_items";
}
elseif ( $category_id ) {
	// BEGIN - MultiCategory Display - deneb
	$cat_ids = explode(",",$category_id);
	if (count($cat_ids) > 1){
		$multi_cats = 1;
	}
	// END - MultiCategory Display - deneb

	$q  = "SELECT DISTINCT product_sku FROM #__{vm}_product, #__{vm}_product_category_xref, #__{vm}_category WHERE \n";
	$q .= "(#__{vm}_product.product_parent_id='' OR #__{vm}_product.product_parent_id='0') \n";
	$q .= "AND #__{vm}_product.product_id=#__{vm}_product_category_xref.product_id \n";
	$q .= "AND #__{vm}_category.category_id=#__{vm}_product_category_xref.category_id \n";
	// BEGIN - MultiCategory Display - deneb
	if ($multi_cats){
		$i = 1;
		$q .= "AND (";
		foreach ($cat_ids as $cat_id){
			if ($i == count($cat_ids)){
				$q .= "(#__{vm}_category.category_id='$cat_id')";
			} else {
				$q .= "(#__{vm}_category.category_id='$cat_id') OR \n";
			}
			$i++;
		}
		$q .= ")  \n";
	} else {
		$q .= "AND #__{vm}_category.category_id='$category_id' \n";
	}
	// END - MultiCategory Display - deneb
	$q .= "AND #__{vm}_product.product_publish='Y' \n";
	$q .= "AND #__{vm}_product.product_special='Y' \n";
	if( CHECK_STOCK && PSHOP_SHOW_OUT_OF_STOCK_PRODUCTS != "1") {
		$q .= " AND product_in_stock > 0 \n";
	}
	$q .= "ORDER BY RAND() LIMIT 0, $max_items";
}
else {
	$q  = "SELECT DISTINCT product_sku FROM #__{vm}_product WHERE ";
	$q .= "(#__{vm}_product.product_parent_id='' OR #__{vm}_product.product_parent_id='0') AND vendor_id='".$_SESSION['ps_vendor_id']."' ";
	$q .= "AND #__{vm}_product.product_publish='Y' ";
	$q .= "AND #__{vm}_product.product_special='Y' ";
	if( CHECK_STOCK && PSHOP_SHOW_OUT_OF_STOCK_PRODUCTS != "1") {
		$q .= " AND product_in_stock > 0 ";
	}
	$q .= "ORDER BY RAND() LIMIT 0, $max_items";
}
$db->query($q);
if( $db->num_rows() > 0 ) {
	$width = intval(100 / intval($db->num_rows()));
	?>
	<table border="0" cellpadding="0" cellspacing="0" width="100%">
	<?php
	$i = 0;
	while($db->next_record() ){
		if ($i%2)
		$sectioncolor = "sectiontableentry2";
		else
		$sectioncolor = "sectiontableentry1";

		if( $display_style == "vertical" ) {
        ?>
			<tr align="center" class="<?php echo $sectioncolor ?>">
				<td width="<?php echo $width ?>%">
					<?php
					load_product_snapshot($personal_template, $show_product_title, $title_font_size, $title_font_color, $price_font_size, $price_font_color, $db->f("product_sku"), $show_price, $show_addtocart);
					?><br />
				</td>
			</tr>
		<?php
		}
		elseif( $display_style== "horizontal" ) {
			if( $i == 0 )
			echo "<tr>\n";
			echo "<td width=\"$width%\" align=\"center\">";
			load_product_snapshot($personal_template, $show_product_title, $title_font_size, $title_font_color, $price_font_size, $price_font_color, $db->f("product_sku"), $show_price, $show_addtocart);
			echo "</td>\n";
			if( ($i+1) == $db->num_rows() )
			echo "</tr>\n";
		}
		elseif( $display_style== "table" ) {
			if( $i == 0 )
			echo "<tr>\n";
			echo "<td width=\"$width%\" align=\"center\">";
			load_product_snapshot($personal_template, $show_product_title, $title_font_size, $title_font_color, $price_font_size, $price_font_color, $db->f("product_sku"), $show_price, $show_addtocart);
			echo "</td>\n";
			if ( ($i+1) % $products_per_row == 0)
			echo "</tr><tr>\n";
			if( ($i+1) == $max_items )
			echo "</tr>\n";
		}
		$i++;
	}
?>
</table>
<?php
}

function load_product_snapshot( $personal_template, $show_product_title, $title_font_size, $title_font_color, $price_font_size, $price_font_color, $product_sku, $show_price=true, $show_addtocart=true, $show_product_name = true ) {
	if ($personal_template) {
		show_feature_snapshot($product_sku, $show_product_title, $title_font_size, $title_font_color, $price_font_size, $price_font_color, $show_price, $show_addtocart);
	} else {
		require_once ( CLASSPATH. 'ps_product.php');
		$ps_product = new ps_product;
		$ps_product->show_snapshot($product_sku, $show_price, $show_addtocart);
	}
}

function show_feature_snapshot( $product_sku, $show_product_title, $title_font_size, $title_font_color, $price_font_size, $price_font_color, $show_price=true, $show_addtocart=true, $show_product_name = true ) {
	echo product_feature_snapshot( $product_sku, $show_product_title, $title_font_size, $title_font_color, $price_font_size, $price_font_color, $show_price, $show_addtocart, $show_product_name );
}

function product_feature_snapshot( $product_sku, $show_product_title, $title_font_size, $title_font_color, $price_font_size, $price_font_color, $show_price=true, $show_addtocart=true, $show_product_name = true ) {

	global $sess, $mm_action_url;

	$db = new ps_DB;

	require_once(CLASSPATH.'ps_product_category.php');
	$ps_product_category = new ps_product_category;
	require_once(CLASSPATH.'ps_product.php');
	$ps_product = new ps_product;

	$q = "SELECT product_id, product_name, product_parent_id, product_thumb_image FROM #__{vm}_product WHERE product_sku='$product_sku'";
	$db->query( $q );

	if ($db->next_record()) {
		$product_id = $db->f("product_id" );
		$tpl = new $GLOBALS['VM_THEMECLASS']();

		$cid = $ps_product_category->get_cid( $product_id );

		$tpl->set( 'product_id', $product_id);
		$tpl->set( 'product_name', $db->f("product_name") );
		$tpl->set( 'show_product_name', $show_product_name );

		if ($db->f("product_parent_id")) {
			$url = "?page=shop.product_details&category_id=$cid&flypage=".$ps_product->get_flypage($db->f("product_parent_id"));
			$url .= "&product_id=" . $db->f("product_parent_id");
		} else {
			$url = "?page=shop.product_details&category_id=$cid&flypage=".$ps_product->get_flypage($db->f("product_id"));
			$url .= "&product_id=" . $db->f("product_id");
		}
		$product_link = $sess->url($mm_action_url. "index.php" . $url);
		$tpl->set( 'product_link', $product_link );
		$tpl->set( 'product_thumb_image', $db->f("product_thumb_image"), "alt=\"".$db->f("product_name")."\"");

		if (_SHOW_PRICES == '1' && $show_price) {
			// Show price, but without "including X% tax"
			$price = $ps_product->show_price( $db->f("product_id"), true );
			$tpl->set( 'price', $price );
		}
		if (USE_AS_CATALOGUE != 1 && $show_addtocart
				&& isset( $GLOBALS['product_info'][$product_id]['price']['product_price_id'] ) // Product must have a price to add it to cart
				&& !$ps_product->product_has_attributes($product_id, true)  // Parent Products and Products with attributes can't be added to cart this way
				) {
			$url = "?page=shop.cart&func=cartAdd&product_id=" .  $db->f("product_id");
			$addtocart_link = $sess->url($mm_action_url. "index.php" . $url);
			$tpl->set( 'addtocart_link', $addtocart_link );
		}

		$tpl->set( 'show_product_title', $show_product_title );
		$tpl->set( 'title_font_size', $title_font_size );
		$tpl->set( 'title_font_color', $title_font_color );
		$tpl->set( 'price_font_size', $price_font_size );
		$tpl->set( 'price_font_color', $price_font_color );

		return fetch_feature( 'productsnapshot.tpl.php',$tpl);
	}
	return '';
}

function fetch_feature($file, $tpl) {
	extract($tpl->vars);          // Extract the vars to local namespace
	ob_start();                    // Start output buffering
	if( file_exists(JPATH_BASE . '/modules/mod_virtuemart_featureprod_advanced/' . $file) ) {
		include(JPATH_BASE . '/modules/mod_virtuemart_featureprod_advanced/' . $file);  // Include the file
	} elseif( file_exists( $tpl->default_path . $file ) ) {
		include( $tpl->default_path . $file );
	}
	$contents = ob_get_contents(); // Get the contents of the buffer
	ob_end_clean();                // End buffering and discard
	return $contents;              // Return the contents
}
?>